* ADD_LOG.PRG
* >L<
* Demo Coverage AddIn, Shows multiple logs being examined


LPARAMETERS toCoverageRef

LOCAL ARRAY laTemp[1]

LOCAL lcExact, lcNewFormName, ;
      lcNewSourceAlias, ;
      lcNewTargetAlias, ;
      lcOldSourceFile, llReturn, lcPath

lcExact = SET("EXACT")
SET EXACT ON

DO CASE
CASE TYPE("toCoverageRef.BaseClass") # "C" OR ;
      ACLASS(latemp,toCoverageRef) = 0 OR ;
      ASCAN(latemp,"COV_STANDARD") = 0
   
      MESSAGEBOX("This Demo AddIn is designed to be used only"+ CHR(13)+;
                "a Coverage Object of the Standard UI class"+CHR(13)+ ;
                 "(COV_STANDARD).",;
                16)
              
CASE toCoverageRef.lUnattended
   MESSAGEBOX("This Demo AddIn is not designed to be used "+ CHR(13)+;
              "when the Coverage Engine is running in "+CHR(13)+ ;
              "Unattended mode."+ ;
              CHR(13)+CHR(13)+;
              "For this AddIn, use .F. as your second parameter:"+;
              CHR(13)+CHR(13)+;
              "DO (_COVERAGE) WITH <logfile>,.F.,"+toCoverageRef.cAddIn,;
              16)
OTHERWISE
   llReturn = .T.
ENDCASE
SET EXACT &lcExact   
IF NOT llReturn
   RETURN .F.
ENDIF   

* give the new dialog we're going to add a unique name: 
lcNewFormName = "frm"+SYS(2015)
* save current Engine file information:
lcOldSourceFile = toCoverageRef.cSourceFile
* create some unique aliases
lcNewSourceAlias = "s"+SYS(2015)
lcNewTargetAlias = "t"+SUBSTR(lcNewSourceAlias,2)
* create the new workfiles
IF toCoverageRef.SetUpWorkFiles(, ;
                 lcNewSourceAlias,lcNewTargetAlias) ;
   AND USED(lcNewTargetAlias)

   * instantiate the dialog, into the frame if necessary,
   * letting it know what target file it is supposed to
   * be working with:
   IF toCoverageRef.lInCoverageFrame
      toCoverageRef.oFrame.Show()
   ENDIF
   toCoverageRef.ADDOBJECT(lcNewFormName,;
                           "frmAdditionalDialog", ;
                           lcNewTargetAlias)
   toCoverageRef.&lcNewFormName..Show()
ENDIF   

* now let's add another one, with yet a third interface:

IF FILE("GR_STATS.SCX")
   lcPath = ""
ELSE
   lcPath = SYS(16)
   lcPath = SUBSTR(lcPath,1,RAT("\",lcPath))
ENDIF   

IF FILE(lcPath+"GR_STATS.SCX")
   lcNewSourceAlias = "s"+SYS(2015)
   lcNewTargetAlias = "t"+SUBSTR(lcNewSourceAlias,2)
   IF toCoverageRef.SetUpWorkFiles(, ;
                    lcNewSourceAlias,lcNewTargetAlias) ;
      AND USED(lcNewTargetAlias)
   
      * this one doesn't happen to be in the formset,
      * but it will still work pretty well:
   
      DO FORM (lcPath+"GR_STATS") WITH toCoverageRef, lcNewSourceAlias, lcNewTargetAlias
      * GR_STATS will default to looking at current .cTargetAlias and .cSourceAlias,
      * but we want to focus its attention on a particular pair of workfiles,
      * so we'll pass them in... 

   ENDIF   
ENDIF   

* put the old information back in the Engine, since
* the standard UI dialog expects it there:

toCoverageRef.cSourceFile = lcOldSourceFile

* Note that we haven't touched the standard aliases 
* or the original log in any way.  

* A different subclass of the Engine, not cov_standard,
* could maintain these different workfile pairs and 
* an array of the aliases, and switch back and forth depending
* on which of many dialogs were open.  These dialogs could
* all be of the same class if you liked, and the pairs of
* main and zoom dialogs could also be maintained for each
* alias set, with appropriate properties to allow them to
* remain in synch with one another and the workfile pair
* to which they "belonged".

************

* This is a *very* rudimentary dialog class, not subclassed or
* in any way connected with frmMainDialog.

DEFINE CLASS frmAdditionalDialog AS form

   Left = 0
   Top  = 0
   ShowWindow = 1
   Name = "frmSecondDialog"
   KeyPreview = .T.
   cMarkedCodeField = ""
   nMargin = SYSMETRIC(3)
   lInProfileMode = .F.
  
   ADD OBJECT lstAvailableObjectsAndProcs AS listbox WITH ;
      Name = "lstAvailableObjectsAndProcs", ;
      FontName = toCoverageRef.cBaseFontName, ;
      FontSize = toCoverageRef.nBaseFontSize, ;
      FontItalic = toCoverageRef.lBaseFontItalic, ;
      FontBold = toCoverageRef.lBaseFontBold, ;      
      DragMode = 1, ;
      RowSourceType = 2, ;
      ColumnCount = 2

   ADD OBJECT edtMarkedCode AS editbox WITH ;
      Name = "edtMarkedCode", ;
      FontName = toCoverageRef.cBaseMonoFontName, ;
      FontSize = toCoverageRef.nBaseMonoFontSize, ;
      FontItalic = toCoverageRef.lBaseMonoFontItalic, ;
      FontBold = toCoverageRef.lBaseMonoFontBold, ;
      DragMode = 1

   PROC RightClick
      THISFORMSET.StandardRightClick()
   ENDPROC
   
   PROC Keypress(nKeyCode, nShiftAltCtrl)
     THISFORMSET.frmMainDialog.KeyPress(nKeyCode, nShiftAltCtrl)
   ENDPROC
  
   PROC lstAvailableObjectsAndProcs.DragDrop(oSource,nXCoord,nYCoord)
      THISFORM.DragDrop(oSource, nXCoord, nYCoord)
   ENDPROC
   
   PROC edtMarkedCode.DragDrop(oSource, nXCoord, nYCoord)
      THISFORM.DragDrop(oSource, nXCoord, nYCoord)
   ENDPROC
 
   PROC DragDrop(oSource, nXCoord, nYCoord)
      DO CASE
      CASE UPPER(oSource.Name) == ;
           UPPER(THIS.Controls(1).Name) ;
           AND ;
           BETWEEN(nYCoord, ;
                   THIS.nMargin, ;
                   THIS.Height - (THIS.nMargin * 7))

         THIS.lstAvailableObjectsAndProcs.Height = nYCoord

         THIS.edtMarkedCode.Top = ;            
              (THIS.lstAvailableObjectsAndProcs.Height + ;
               (THIS.nMargin * 2))
              
         THIS.edtMarkedCode.Height = ;
              THIS.Height - ;
              (THIS.edtMarkedCode.Top + ;
               THIS.nMargin )

      CASE UPPER(oSource.Name) == ;
           UPPER(THIS.Controls(2).Name) ;
           AND ;
           BETWEEN(nYCoord, ;
                 THIS.nMargin * 4, ;
                 THIS.Height - (THIS.nMargin * 3))

         THIS.edtMarkedCode.Top = nYCoord
         THIS.edtMarkedCode.Height = ;
              THIS.Height - (nYCoord + THIS.nMargin)
         THIS.lstAvailableObjectsAndProcs.Height = ;
              (THIS.edtMarkedCode.Top - (THIS.nMargin * 3))
             
      OTHERWISE
         ?? CHR(7)
      ENDCASE
   ENDPROC
   
   PROC Resize
           
      STORE THIS.Width - (THIS.nMargin*2) TO ;
            THIS.edtMarkedCode.Width, ;
            THIS.lstAvailableObjectsAndProcs.Width
            
      STORE STR(THIS.Width/2)+","+STR(THIS.Width/2) TO ;
           THIS.lstAvailableObjectsAndProcs.ColumnWidths
           
      STORE (THIS.Height - (THIS.nMargin*3))/2 TO ;
            THIS.edtMarkedCode.Height, ;
            THIS.lstAvailableObjectsAndProcs.Height
            
      STORE THIS.lstAvailableObjectsAndProcs.Height + ;
            (THIS.nMargin*2) TO ;
            THIS.edtMarkedCode.Top

   ENDPROC
   

   PROC Init(tcTargetAlias)
      
      IF NOT TYPE("THISFORMSET.frmMainDialog.lInZoomMode") = "L"
         * quick & dirty addtl check to make sure we're
         * instantiated by the right kind of class
         RETURN .F.
      ENDIF
   
      THIS.SetInitialPropertyValues()
 
      STORE tcTargetAlias TO ;
            THIS.lstAvailableObjectsAndProcs.RowSource
      STORE THIS.cMarkedCodeField TO THIS.edtMarkedCode.ControlSource

      STORE THIS.nMargin TO ;
            THIS.edtMarkedCode.Left, ;
            THIS.lstAvailableObjectsAndProcs.Left, ;
            THIS.lstAvailableObjectsAndProcs.Top
            
      STORE THIS.Width - (THIS.nMargin*2) TO ;
            THIS.edtMarkedCode.Width, ;
            THIS.lstAvailableObjectsAndProcs.Width

      THIS.Resize()
                            
   ENDPROC
   
   PROC SetInitialPropertyValues()
   
      THIS.MinHeight = THISFORMSET.frmMainDialog.MinHeight
      THIS.MinWidth = THISFORMSET.frmMainDialog.MinWidth
      THIS.Height = THISFORMSET.frmMainDialog.Height
      THIS.Width = THISFORMSET.frmMainDialog.Width
   
      THIS.nMargin = THISFORMSET.frmMainDialog.nMargin
      THIS.lInProfileMode = THISFORMSET.lInProfileMode
    
   
      THIS.cMarkedCodeField = IIF(THIS.lInProfileMode, ;
                                 "Profiled", "Marked")    
   ENDPROC

   PROC lstAvailableObjectsAndProcs.Destroy
      LOCAL lcAliasName
      lcAliasName = THIS.RowSource
      * get rid of source and target cursors for
      * this dialog:
      USE IN ("s"+SUBSTR(lcAliasName,2))
      USE IN (lcAliasName)
   ENDPROC

   PROC lstAvailableObjectsAndProcs.When
      LOCAL llProfileMode
      IF EMPTY(EVAL(THIS.RowSource+"."+THISFORM.cMarkedCodeField))
         llProfileMode = THISFORMSET.lInProfileMode
         THISFORMSET.lInProfileMode = THISFORM.lInProfileMode
         THISFORMSET.MarkTargetCoverage(,THIS.RowSource)
         THISFORMSET.lInProfileMode = llProfileMode
      ENDIF
      THISFORM.edtMarkedCode.Refresh()      
      
      THISFORM.Caption = ;
           ALLTR(EVAL(THIS.RowSource+".HostFile"))
      IF EMPTY(EVAL(THIS.RowSource+".ObjClass"))
         THISFORM.Caption = THISFORM.Caption+ ": ALL Classes & Procs"
      ELSE
         THISFORM.Caption = THISFORM.Caption + ": " + ;
                    ALLTR(EVAL(THIS.RowSource+".ObjClass"))
      ENDIF
   ENDPROC

ENDDEFINE
