* ADD_UI.PRG
*>L<
* Demo Coverage AddIn, 
* Adds a Button to the Standard UI Main Dialog
* using the recommended method (the dialog's AddTool() method)
* -- this button calls another addin, the Find dialog.

* Both buttons are descended from a button class
* that shows you the Coverage standard error 
* handling, although this is not required for
* buttons you add to the Coverage app!

* Classes are DEFINEd within this PRG for
* convenience, but CLASSLIBs could be SET etc

LPARAMETERS toCoverageRef

LOCAL ARRAY laTemp[1]

LOCAL lcExact, lcName, llReturn, loControl

lcExact = SET("EXACT")
SET EXACT ON

DO CASE

CASE TYPE("toCoverageRef.BaseClass") # "C" OR ;
   ACLASS(laTemp,toCoverageRef) = 0 OR ;
   ASCAN(laTemp,"COV_STANDARD") = 0
   
   MESSAGEBOX("This Demo AddIn requires a Coverage Object "+CHR(13)+;
              "descended from the Standard UI class (COV_STANDARD).",;
             16)
              
   
CASE toCoverageRef.lUnattended

   MESSAGEBOX("This Demo AddIn is not designed to be used "+ CHR(13)+;
              "when the Coverage Engine is running in "+CHR(13)+ ;
              "Unattended mode."+ ;
              CHR(13)+CHR(13)+;
              "For this AddIn, use .F. as your second parameter:"+;
              CHR(13)+CHR(13)+;
              "DO (_COVERAGE) WITH <logfile>,.F.,"+toCoverageRef.cAddIn,;
              16)
OTHERWISE
  
  llReturn = .T.

ENDCASE

SET EXACT &lcExact   

IF llReturn
   FOR EACH loControl IN toCoverageRef.frmMainDialog.cntTools.Controls
      IF UPPER(loControl.Class) == "DEMOFINDBUTTON"
         ??CHR(7)
         WAIT WINDOW "Already added!" NOWAIT
         llReturn = .F.
         EXIT
      ENDIF
   ENDFOR
ENDIF   

IF llReturn
   toCoverageRef.frmMainDialog.AddTool("DemoFindButton")   
ENDIF    

RETURN llReturn


DEFINE Class DemoFindButton AS CoverageToolButton

   Caption = "\<Find..."
  
   PROC Click
      LOCAL lcFile
     
      lcFile = UPPER(SYS(16))

      IF LEFT(lcFile,10) = "PROCEDURE "
         lcFile = ;
          SUBSTR(lcFile,AT(" ",lcFile,2) + 1)
      ENDIF
  
      lcFile = STRTRAN(lcFile,;
                    SUBSTR(lcFile,RAT("\",lcFile)+1), ;
                    "FIND_REC.SCX")
      IF NOT FILE(lcFile)
  
        lcFile = THISFORMSET.GetResourceLocation( ;
                lcFile, ;
                "Please locate Find_Rec AddIn", ;
                "Forms" + " (*.scx)|*.scx", ;
                "FIND_REC.SCX", ;
                "GETFILE")
      ENDIF                
  
     THISFORMSET.RunAddIn(lcFile)
     
  ENDPROC

ENDDEFINE


DEFINE CLASS CoverageToolButton AS CommandButton
   * this class simply demonstrates
   * standard (not required!) 
   * Coverage member error handling
   * and shows you how a UI element can
   * take advantage of cov_standard UI properties

   lError = .F.
   AutoSize = .T.   

   PROC Init
      * use some formset properties to
      * make the new tool "fit in"

      WITH THISFORMSET
         THIS.FontName = .cBaseFontName
         THIS.FontItalic = .lBaseFontItalic
         THIS.FontBold = .lBaseFontBold
         THIS.FontSize = .nBaseFontSize
      ENDWITH
      
      * The Autosize in the class def will
      * make sure that the caption for this button
      * fits.  
      
      * Now use the container's physical properties
      * to fit in there as well:
      THIS.Autosize = .F.
     
      WITH THISFORMSET.frmMainDialog.cntTools
         THIS.Top = .Controls(1).Top
         THIS.Height = .Controls(1).Height
      ENDWITH 

   RETURN (NOT THIS.lError)
  
   PROC Error(nError, cMethod, nLine)
      THIS.lError = .T.
      IF TYPE("THISFORMSET.BaseClass") = "C"
         THISFORMSET.Error(nError,THIS.Name+":"+cMethod,nLine)
      ELSE
         ERROR nError
      ENDIF
   ENDPROC
   
ENDDEFINE

