* SAVE_SRC.PRG
* >L< 
* Demo Coverage AddIn, Saves Source Table to Disk

LPARAMETERS toCoverageRef

IF NOT TYPE("toCoverageRef.lUsingRegistry") = "L"
   RETURN .F.
   *&* Q&D check... 
   * see other addins for a more sensible one!
ENDIF   

LOCAL lcDBFName, liSelect, lcSource, liDataSession, llTalk

IF SET("TALK") = "ON"
  SET TALK OFF
  llTalk = .T.
ENDIF  

* get the alias of the current Source table
lcSource = toCoverageRef.cSourceAlias

* get a default tablename for the save-to-disk
* using the engine method that generates one for you:
lcDBFName = toCoverageRef.GetTableName("_SRC")
* This method takes the source log name and adds the
* suffix you pass, but it includes a digit that allows
* it to ensure you don't overwrite.  You end up with
* a default filename that looks like this:
* MyPathedSourceLogName_SRC+ALLTR(STR(expN))+".DBF"

* now ask the user whether this name is okay:
lcDBFName = ;
  toCoverageRef.GetResourceLocation( ;
       toCoverageRef.cSourceFile, ;
      "Please decide where to save the Source table", ;
      "Tables" + " (*.dbf)|*.dbf", ;
      lcDBFName, ;
      "PUTFILE")

IF (NOT(EMPTY(lcDBFName)))

   liDataSession = SET("DATASESSION")
   SET DATASESSION TO toCoverageRef.DataSessionID

   liSelect = SELECT()
   SELECT (lcSource)
   COPY TO (lcDBFName) 
   SELECT (liSelect)
   SET DATASESSION TO liDataSession   
   IF EMPTY(SYS(2000,lcDBFName))
      WAIT WINDOW NOWAIT "Nothing happened!"
      toCoverageRef.lError = .T.
   ENDIF

ENDIF

IF llTalk
   SET TALK ON
ENDIF   

RETURN