* Open the VFP TESTDATA database.

close databases all
open database (_samples + 'DATA\TESTDATA')

* Create a collection of field objects and populate it with fields in the
* CUSTOMER table.

loCollection = newobject('FieldCollection', 'Sample.vcx')
use CUSTOMER
lnFields = afields(laFields)
for lnI = 1 to lnFields
	lcField   = lower(laFields[lnI, 1])
	lcCaption = dbgetprop('customer.' + lcField, 'Field', 'Caption')
	lcCaption = iif(empty(lcCaption), ;
		proper(strtran(laFields[lnI, 1], '_', ' ')), lcCaption)
	loField   = loCollection.AddItem(lcField)
	loField.cType     = laFields[lnI, 2]
	loField.nSize     = laFields[lnI, 3]
	loField.nDecimals = laFields[lnI, 4]
	loField.cCaption  = lcCaption
next lnI

* Now display the fields.

do form FIELDS with loCollection
